;Cybot radio test program - Nigel Goodwin Nov 2001


RHFor		equ	01
LHFor		equ	03
RHBak		equ	00
LHBak		equ	02
Ser_In          Equ     04	;bit position for RS232 in

d1		equ	20
d2		equ	21
del		equ	22
Bit_Cntr        Equ     23	;bit counter for RS232
Xmit_Byte       Equ     24	;holds byte to xmit
Rcv_Byte	Equ	25	;holds received byte
Delay_Count	Equ	26	;delay variable for RS232


;+++++
;	BREVC tests the variable in register 'VAR1' and if it is equal to the constant
;	'CONST', branches to label 'LABEL'.

;	Call as:	BREVC	THIS,THAT,THERE

;	Action:		Tests if THIS = THAT and if they are equal, branches to THERE




BREVC	MACRO	VAR1,CONST,LABEL
	MOVLW	CONST
	SUBWF	VAR1,W
	BZ	LABEL		; Branch if VAR1 = CONST
	ENDM



	LIST	p=16C84 , r=dec
	include "P16C84.inc"
	__config H'3FF9' 


	org	0000
	goto 	start
	org	0004

; Subroutines

; call 100mS delay number of times in W
Delay	movwf	del
DelLoop	call 	Del100
	decfsz	del, f
	goto	DelLoop
	return

; 100mS delay
Del100	movlw	0x8d
	movwf	d1
Delay_00
	movlw	0xeb
	movwf	d2
Delay_01
	decfsz	d2, f
	goto	Delay_01
	decfsz	d1, f
	goto	Delay_00

			;25 cycles
	movlw	0x08
	movwf	d1
Delay_10
	decfsz	d1, f
	goto	Delay_10

			;1 cycles
	nop

			;4 cycles (including call)
	return


;input byte fron Ser_In at 9600 baud

Rcv_RS232       BTFSS   PORTB     , Ser_In	;wait for start bit
                GOTO    Rcv_RS232		;do half bit time delay
                CALL    Start_Delay
                BTFSS   PORTB     , Ser_In	;confirm still in start bit
                GOTO    Rcv_RS232
                MOVLW   0x08			;set up to read 8 bits
                MOVWF   Bit_Cntr
                CLRF    Rcv_Byte
Next_RcvBit     CALL    Bit_Delay
                BTFSC   PORTB     , Ser_In
                BCF     STATUS    , C
                BTFSS   PORTB     , Ser_In
                BSF     STATUS    , C
                RRF     Rcv_Byte  , f
                DECFSZ  Bit_Cntr  , f
                GOTO    Next_RcvBit
                CALL    Bit_Delay
		CALL    Start_Delay
                BTFSC   PORTB     , Ser_In	;check valid stop bit.
		GOTO    Rcv_RS232
                RETURN

Start_Delay     MOVLW   0x0C
                MOVWF   Delay_Count
Start_Wait      NOP
                DECFSZ  Delay_Count , f
                GOTO    Start_Wait
                RETURN

Bit_Delay       MOVLW   0x18
                MOVWF   Delay_Count
Bit_Wait        NOP
                DECFSZ  Delay_Count , f
                GOTO    Bit_Wait
                RETURN

STOP		; stop both motors
	bcf	PORTB,RHBak
	bcf	PORTB,LHBak
	bcf	PORTB,RHFor
	bcf	PORTB,LHFor
	return

FORWARD		; both motors forward
	bcf	PORTB,RHBak
	bcf	PORTB,LHBak
	bsf	PORTB,RHFor
	bsf	PORTB,LHFor
	return

BACKWARD	; both motors backward
	bsf	PORTB,RHBak
	bsf	PORTB,LHBak
	bcf	PORTB,RHFor
	bcf	PORTB,LHFor
	return

LEFT		; RH motor forwards
	bcf	PORTB,RHBak
	bcf	PORTB,LHBak
	bsf	PORTB,RHFor
	bcf	PORTB,LHFor
	return

RIGHT		; LH motor forwards
	bcf	PORTB,RHBak
	bcf	PORTB,LHBak
	bcf	PORTB,RHFor
	bsf	PORTB,LHFor
	return

SPINL		; RH motor forwards, LH motor backwards
	bcf	PORTB,RHBak
	bsf	PORTB,LHBak
	bsf	PORTB,RHFor
	bcf	PORTB,LHFor
	return

SPINR		; LH motor forwards, RH motor backwards
	bsf	PORTB,RHBak
	bcf	PORTB,LHBak
	bcf	PORTB,RHFor
	bsf	PORTB,LHFor
	return

Chk_Ser
	call	Rcv_RS232
	BREVC	Rcv_Byte, 'S', STOP
	BREVC	Rcv_Byte, 'F', FORWARD
	BREVC	Rcv_Byte, 'B', BACKWARD
	BREVC	Rcv_Byte, 'L', LEFT
	BREVC	Rcv_Byte, 'R', RIGHT
	BREVC	Rcv_Byte, 0x00, STOP
	return

; End of subroutines

; Start of main program

; Define port directions (all A as outputs)
start	movlw 	0
	; set bank 1
	bsf	STATUS, RP0
	movwf	TRISA
	movlw 	b'00010000'	;set B4 as input
	movwf	TRISB
	; set bank 0
	bcf	STATUS, RP0


	call	STOP	;ensure all lines are turned off!.

Loop	call Chk_Ser
	goto	Loop	;loop back to start and run for ever.




	END
